/*
 * segatex SELinux tool.
 *
 * Copyright (C) 2007 Shintaro Fujiwara 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * */

#include <qlayout.h>
#include <qpushbutton.h>
#include <qprocess.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qlineedit.h>
#include <qtextedit.h>
#include <qregexp.h>

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fstream>

#include "semanage_core_fcontext_process.h"

#include <iostream>
using namespace std;

//default constructor
SemanageCoreFcontextProcess::SemanageCoreFcontextProcess(QWidget *parent, const char *name): QDialog(parent, name)
{
	setCaption(tr("Semanage Fcontext Process"));
	textEdit1 = new QTextEdit(this);
	textEdit1->setPaletteBackgroundColor(QColor(0,254,100));

	semanageEditLabel = new QLabel(tr("Add fcontext:"), this );
	semanageEditLabel2 = new QLabel(tr("file_spec:"), this );
	semanageEditLineEdit = new QLineEdit( this );
	semanageEditLineEdit2 = new QLineEdit( this );
	semanageEditLineEdit->setText("");
	semanageEditLineEdit->setPaletteBackgroundColor(QColor(255,100,200));
	semanageEditLineEdit2->setText("\"write path here\"");
	semanageEditLineEdit2->setPaletteBackgroundColor(QColor(255,100,200));
	addButton = new QPushButton(tr("Add fcontext"), this);
	addButton->setPaletteBackgroundColor(QColor(20,157,100));
	connect(addButton, SIGNAL(clicked()), this, SLOT(add_button_clicked()));

	semanageEditLabel3 = new QLabel(tr("Delete fcontext(file_spec):"), this );
	semanageEditLineEdit3 = new QLineEdit( this );
	semanageEditLineEdit3->setText("\"write path here\"");
	semanageEditLineEdit3->setPaletteBackgroundColor(QColor(255,100,200));
	deleteButton = new QPushButton(tr("Delete fcontext"), this);
	deleteButton->setPaletteBackgroundColor(QColor(20,157,100));
	connect(deleteButton, SIGNAL(clicked()), this, SLOT(delete_button_clicked()));

	semanageEditLabel4 = new QLabel(tr("Modify fcontext:"), this );
	semanageEditLabel5 = new QLabel(tr("file_spec:"), this );
	semanageEditLineEdit4 = new QLineEdit( this );
	semanageEditLineEdit5 = new QLineEdit( this );
	semanageEditLineEdit4->setText("");
	semanageEditLineEdit4->setPaletteBackgroundColor(QColor(255,100,200));
	semanageEditLineEdit5->setText("\"write path here\"");
	semanageEditLineEdit5->setPaletteBackgroundColor(QColor(255,100,200));
	modifyButton = new QPushButton(tr("Modify fcontext"), this);
	modifyButton->setPaletteBackgroundColor(QColor(20,157,100));
	connect(modifyButton, SIGNAL(clicked()), this, SLOT(modify_button_clicked()));

	closeButton = new QPushButton(tr("close"), this);
	//closing process button
	connect(closeButton, SIGNAL(clicked()), this, SLOT(close()));
	closeButton->setDefault(true);

	//set textEdit smanage such and such -l
	semanage_core_base_fcontext_process();

	mainLayout = new QVBoxLayout(this);
	mainLayout->setMargin(11);

	upperLayout = new QVBoxLayout;
	upperLayout->addWidget(textEdit1);

	middleLayout = new QVBoxLayout;
	leftLayout = new QHBoxLayout;
	rightLayout = new QHBoxLayout;
	thirdLayout = new QHBoxLayout;
	
	leftLayout->addWidget(semanageEditLabel);
	leftLayout->addWidget(semanageEditLineEdit);
	leftLayout->addWidget(semanageEditLabel2);
	leftLayout->addWidget(semanageEditLineEdit2);
	leftLayout->addWidget(addButton);
	rightLayout->addWidget(semanageEditLabel3);
	rightLayout->addWidget(semanageEditLineEdit3);
	rightLayout->addWidget(deleteButton);
	thirdLayout->addWidget(semanageEditLabel4);
	thirdLayout->addWidget(semanageEditLineEdit4);
	thirdLayout->addWidget(semanageEditLabel5);
	thirdLayout->addWidget(semanageEditLineEdit5);
	thirdLayout->addWidget(modifyButton);

	middleLayout->addLayout(leftLayout);
	middleLayout->addLayout(rightLayout);
	middleLayout->addLayout(thirdLayout);

	footLayout = new QHBoxLayout;
	footLayout->addStretch();
	footLayout->addWidget(closeButton);

	mainLayout->addLayout(upperLayout);
	mainLayout->addLayout(middleLayout);
	mainLayout->addLayout(footLayout);
	resize(1000,600);
}

/*signal and slot should have same argument pattern so I had to pass to another slot*/
void SemanageCoreFcontextProcess::add_button_clicked()
{
	semanageEditLineEdit_str = semanageEditLineEdit->text();
	semanageEditLineEdit2_str = semanageEditLineEdit2->text();
	add_button_clicked_process(semanageEditLineEdit_str,semanageEditLineEdit2_str);
}
/*signal and slot should have same argument pattern so I had to pass to another slot*/
void SemanageCoreFcontextProcess::delete_button_clicked()
{
	semanageEditLineEdit3_str = semanageEditLineEdit3->text();
	delete_button_clicked_process(semanageEditLineEdit3_str);
}
/*signal and slot should have same argument pattern so I had to pass to another slot*/
void SemanageCoreFcontextProcess::modify_button_clicked()
{
	semanageEditLineEdit4_str = semanageEditLineEdit4->text();
	semanageEditLineEdit5_str = semanageEditLineEdit5->text();
	modify_button_clicked_process(semanageEditLineEdit4_str,semanageEditLineEdit5_str);
}
/* this slot does just make .pp file */
void SemanageCoreFcontextProcess::add_button_clicked_process(QString semanageEditLineEdit_str, QString semanageEditLineEdit2_str)
{
	//QRegExp rx_path("/[a-zA-Z]+");
	//int i = string.find( QRegExp("an"), 0 );    // i == 1
	//int i = semanageEditLineEdit2_str.find( QRegExp("[/a-zA-Z0-9]+"), 0 );    // i == 1
	semanageEditLineEdit2_str_for_check = semanageEditLineEdit2_str;
	semanageEditLineEdit2_str_for_check.replace( QChar('"'), "" );
	s_first = semanageEditLineEdit2_str_for_check.section('/', 1, 1 );
	int i_first = s_first.find( QRegExp("[^a-zA-Z0-9_]"), 0 );    // i == 1
	cout << "s_first:" << s_first << endl;
	cout << "i_first:" << i_first << endl;
	restorecon_str = "default";
	if(i_first > 0 ){
		s_first_for_restorecon_str = s_first.mid(0,i_first);
		restorecon_str = "/" + s_first_for_restorecon_str;
		cout << "restorecon_str:" << restorecon_str << endl;
	}

	s_second = semanageEditLineEdit2_str_for_check.section('/', 2, 2 );
	int i_second = s_second.find( QRegExp("[^a-zA-Z0-9_]"), 0 );    // i == 1
	cout << "s_second:" << s_second << endl;
	cout << "i_second:" << i_second << endl;
	if(i_second > 0 ){
		s_second_for_restorecon_str = s_second.mid(0,i_second);
		restorecon_str = "/" + s_first + "/" + s_second_for_restorecon_str;
		cout << "restorecon_str:" << restorecon_str << endl;
	}

	s_third = semanageEditLineEdit2_str_for_check.section('/', 3, 3 );
	int i_third = s_third.find( QRegExp("[^a-zA-Z0-9_]"), 0 );    // i == 1
	cout << "s_third:" << s_third << endl;
	cout << "i_third:" << i_third << endl;
	if(i_third > 0 ){
		s_third_for_restorecon_str = s_third.mid(0,i_third);
		restorecon_str = "/" + s_first + "/" + s_second + "/" + s_third_for_restorecon_str;
		cout << "restorecon_str:" << restorecon_str << endl;
	}

	s_fourth = semanageEditLineEdit2_str_for_check.section('/', 4, 4 );
	int i_fourth = s_fourth.find( QRegExp("[^a-zA-Z0-9_]"), 0 );    // i == 1
	cout << "s_fourth:" << s_fourth << endl;
	cout << "i_fourth:" << i_fourth << endl;
	if(i_fourth > 0 ){
		s_fourth_for_restorecon_str = s_fourth.mid(0,i_fourth);
		restorecon_str = "/" + s_first + "/" + s_second + "/" + s_third + "/" + s_fourth_for_restorecon_str;
		cout << "restorecon_str:" << restorecon_str << endl;
	}
	if(restorecon_str == "default"){
		restorecon_str = "/" + s_first + "/" + s_second + "/" + s_third + "/" + s_fourth_for_restorecon_str;
		cout << "restorecon_str:" << restorecon_str << endl;
	}


	semanageEditLineEdit_str_pp = "semanage fcontext -a -t " + semanageEditLineEdit_str + " " + semanageEditLineEdit2_str;
        #define PWD_BUF 8600
        const char* make_module_file="/root/segatex/semanage/add_fcontexted";
        ofstream os_add;
        os_add.open(make_module_file);
        if(os_add){
                FILE *read_fp;
                #define SIZE_TMP 8600
                char buffer[SIZE_TMP];
                int chars_read;
                memset(buffer, '\0', sizeof(buffer));
                read_fp = popen(semanageEditLineEdit_str_pp, "r");
                if(read_fp != NULL){
                        chars_read = fread(buffer, sizeof(char), SIZE_TMP, read_fp);
                        while(chars_read>0){
                                buffer[chars_read -1] = '\0';
                                //os << "Reading:-" << endl;
                                os_add << buffer << endl;
                                chars_read= fread(buffer, sizeof(char), SIZE_TMP, read_fp);
                        }
                        pclose(read_fp);
                }
        }
	os_add.close();
	
	//Now, let's restorecon path
	semanageEditLineEdit_str_add_restorecon = "restorecon -R " + restorecon_str;
        #define PWD_BUF 8600
        const char* restorecon_file="/root/segatex/semanage/add_fcontexted_restorecon";
        ofstream os_add_restorecon;
        os_add_restorecon.open(restorecon_file);
        if(os_add_restorecon){
                FILE *read_fp;
                #define SIZE_TMP 8600
                char buffer[SIZE_TMP];
                int chars_read;
                memset(buffer, '\0', sizeof(buffer));
                read_fp = popen(semanageEditLineEdit_str_pp, "r");
                if(read_fp != NULL){
                        chars_read = fread(buffer, sizeof(char), SIZE_TMP, read_fp);
                        while(chars_read>0){
                                buffer[chars_read -1] = '\0';
                                //os << "Reading:-" << endl;
                                os_add_restorecon << buffer << endl;
                                chars_read= fread(buffer, sizeof(char), SIZE_TMP, read_fp);
                        }
                        pclose(read_fp);
                }
        }
	os_add_restorecon.close();

	//set textEdit semanage -l
	semanage_core_base_fcontext_process();
	//outputfile_str_common2 = make_module_file;
}
/* this slot does just make .pp file */
void SemanageCoreFcontextProcess::delete_button_clicked_process(QString semanageEditLineEdit3_str)
{
	semanageEditLineEdit_str_pp = "semanage fcontext -d " + semanageEditLineEdit3_str;
        #define PWD_BUF 8600
        const char* make_module_file="/root/segatex/semanage/delete_fcontexted";
        ofstream os_delete;
        os_delete.open(make_module_file);
        if(os_delete){
                FILE *read_fp;
                #define SIZE_TMP 8600
                char buffer[SIZE_TMP];
                int chars_read;
                memset(buffer, '\0', sizeof(buffer));
                read_fp = popen(semanageEditLineEdit_str_pp, "r");
                if(read_fp != NULL){
                        chars_read = fread(buffer, sizeof(char), SIZE_TMP, read_fp);
                        while(chars_read>0){
                                buffer[chars_read -1] = '\0';
                                //os << "Reading:-" << endl;
                                os_delete << buffer << endl;
                                chars_read= fread(buffer, sizeof(char), SIZE_TMP, read_fp);
                        }
                        pclose(read_fp);
                }
        }
	os_delete.close();
	//set textEdit semanage -l
	semanage_core_base_fcontext_process();
	//outputfile_str_common2 = make_module_file;
}
/* this slot does just make .pp file */
void SemanageCoreFcontextProcess::modify_button_clicked_process(QString semanageEditLineEdit4_str, QString semanageEditLineEdit5_str)
{
	semanageEditLineEdit_str_pp = "semanage fcontext -m -t " + semanageEditLineEdit4_str + " " + semanageEditLineEdit5_str;
        #define PWD_BUF 8600
        const char* make_module_file="/root/segatex/semanage/modify_fcontexted";
        ofstream os_modify;
        os_modify.open(make_module_file);
        if(os_modify){
                FILE *read_fp;
                #define SIZE_TMP 8600
                char buffer[SIZE_TMP];
                int chars_read;
                memset(buffer, '\0', sizeof(buffer));
                read_fp = popen(semanageEditLineEdit_str_pp, "r");
                if(read_fp != NULL){
                        chars_read = fread(buffer, sizeof(char), SIZE_TMP, read_fp);
                        while(chars_read>0){
                                buffer[chars_read -1] = '\0';
                                //os << "Reading:-" << endl;
                                os_modify << buffer << endl;
                                chars_read= fread(buffer, sizeof(char), SIZE_TMP, read_fp);
                        }
                        pclose(read_fp);
                }
        }
	os_modify.close();
	//set textEdit semanage -l
	semanage_core_base_fcontext_process();
}

// {boolean|login|user|port|interface|fcontext|translation}

void SemanageCoreFcontextProcess::semanage_core_base_fcontext_process()
{
        #define PWD_BUF 8600
        const char* semanage_fcontext_list_file="/root/segatex/semanage/1_fcontext";
        ofstream os;
        os.open(semanage_fcontext_list_file);
        if(os){
                FILE *read_fp;
                #define SIZE_TMP 8600
                char buffer[SIZE_TMP];
                int chars_read;
                memset(buffer, '\0', sizeof(buffer));

                read_fp = popen("/usr/sbin/semanage fcontext -l", "r");
                if(read_fp != NULL){
                        chars_read = fread(buffer, sizeof(char), SIZE_TMP, read_fp);
                        while(chars_read>0){
                                buffer[chars_read -1] = '\0';
                                //os << "Reading:-" << endl;
                                os << buffer;
                                chars_read= fread(buffer, sizeof(char), SIZE_TMP, read_fp);
			}
			pclose(read_fp);
                }
        }
	os.close();
	//outputfile_str_common = "fcontext_list";
	readFromOutputFile();
}

//this slot should be called from above slot
void SemanageCoreFcontextProcess::readFromOutputFile()
{
	/////////////////////////////////////////////////////////////
	//path = "./";
	path = "/root/segatex/semanage";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	dir.setPath(path);
	dir_name = dir.absPath();
	/////////////////////////////////////////////////////////////
	dir.setFilter( QDir::Files );
        dir.setSorting( QDir::Name );
	//files = dir.entryList(outputfile_str_common);
	files = dir.entryList("*fcontext");
	/////////////////////////////////////////////////////////////
	it_d = files.begin();
	int order_x;
	order_x = 1;
	//first clear it all, unless double the file.
	textEdit1->clear();
		while(it_d != files.end()){
			name = *it_d;
			file_interface_name = dir_name + forward_slash + name;
			QFile file( file_interface_name );
			/*
			QRegExp rx_nologin("nologin");
			QRegExp rx_shutdown("shutdown");
			QRegExp rx_halt("halt");
			QRegExp rx_news("news");
			QRegExp rx_false("false");
			QRegExp rx_sync("sync");
			*/
			if ( file.open( IO_ReadOnly ) ) {
				QTextStream stream( &file );
				////////////////////////////////////////////
				//int i,j,k,l,m,n;	
				if(order_x == 1)
					textEdit1->append("#########fcontext list#########");
					textEdit1->append("");
				/*
				if(order_x == 2)
					textEdit1->append("#########user list#########");
					textEdit1->append("");
				if(order_x == 3)
					textEdit1->append("#########etc passwd list#########");
					textEdit1->append("");
				*/
				while ( !stream.atEnd() ) {
					line_analized = stream.readLine(); // line of text excluding '\n'
					//buttons.push_back(line_analized);
					/*
					i = line_analized.find( rx_nologin, 0);
					j = line_analized.find( rx_shutdown, 0);
					k = line_analized.find( rx_halt, 0);
					l = line_analized.find( rx_news, 0);
					m = line_analized.find( rx_false, 0);
					n = line_analized.find( rx_sync, 0);
					*/
                                        //if((i != -1)||(j != -1)||(k != -1)||(l != -1)||(m != -1)||(n != -1)){
						//do nothing
					//}else{
						textEdit1->append(line_analized);
					//}
				}
				file.close();
				order_x++;
				++it_d;
			}else{
				//do nothing
			}
		}
}
